<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Home extends ADMIN_Controller {

	public function __construct() {
		parent::__construct();
		define('part', $this->admindir.'/dashboard/');
	}

	public function index() {
		$this->template->display(part.'index');
	}

	public function listdata() {
		$filter = $this->input->post('filter');

		$tanggal = isset($filter['tanggal']) ? explode('s/d', $filter['tanggal']) : null;

		$tglAwal = isset($tanggal) ? $tanggal[0] : date('01-m-Y');
		$tglAkhir = isset($tanggal) ? $tanggal[1] : date('d-m-Y');
		$periode = $tglAwal.' s/d '.$tglAkhir;

		// json tanggal di range
		$begin = new DateTime($tglAwal);

		$datetime = new DateTime($tglAkhir);
		$datetime->add(new DateInterval('P1D'));
		$end = $datetime->format('d-m-Y');
		$end = new DateTime($end);

		$interval = DateInterval::createFromDateString('1 day');
		$period = new DatePeriod($begin, $interval, $end);
		$dates = array();

		foreach ($period as $dt) {
			array_push($dates, $dt->format("d-m-Y"));
		}

		$masuks = array();
		$keluars = array();
		$returs = array();
		$lg = count($dates);
		
		for ($i=0; $i < $lg; $i++) { 
			$date = date_sql($dates[$i]);

			array_push($masuks, $this->model->countSum('masuk', $date));
			array_push($keluars, $this->model->countSum('keluar', $date));
			array_push($returs, $this->model->countSum('retur', $date));
		}

		$data = array(
			'set' => $this->model->get('settingan')->row(),
			'masuk' => $this->model->countMasukHarian(),
			'keluar' => $this->model->countKeluarHarian(),	
			'retur' => $this->model->countReturHarian(),
			'periode' => $periode,
			'labels' => json_encode($dates),
			'masuks' => json_encode($masuks), 
			'keluars' => json_encode($keluars), 
			'returs' => json_encode($returs)
		);
		
		$this->load->view(part.'list', $data);
	}

	public function backupdb() {
		$this->load->dbutil();
		$now = date('d-m-Y');

		$prefs = array(
			'format'     => 'zip',
        	'filename'   => 'BackupDB-Master-['.$now.']',
	        'add_drop'   => TRUE,
	        'add_insert' => TRUE,
	        'newline'    => "\n"
		);

		$backup = $this->dbutil->backup($prefs);
		
		$this->load->helper('download');
		force_download('BackupDB-Master-['.$now.'].zip', $backup);
	}
}