<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Login extends ADMIN_Controller
{
    public function __construct()
    {
        parent::__construct();
        define('viewdir', 'login/');

        $this->load->model('UserModel', 'user');
    }

    public function index()
    {
        $post 	= $this->input->post();
        $get	= $this->input->get();
        $usernameSes = $this->session->userdata('username');

        if (!empty($post)) {
            $back			= null;
            $note			= null;
            $usernamePost 	= isset($post['username']) ? $post['username'] : null;
            $passwordPost 	= isset($post['password']) ? $post['password'] : null;

            $this->form_validation->set_rules('password', 'Password', 'required');
            $this->form_validation->set_rules('username', 'Username', 'required');
            
            if ($this->form_validation->run()) {
                if (!empty($usernamePost) && !empty($passwordPost)) {
                    $username = $usernamePost;
                    $password = md5($passwordPost);
    
                    $result	 = $this->user->cekUser($username, $password)->row();
                    $cek 	 = isset($result);
    
                    if ($cek) {
                        $this->session->unset_userdata('username');
                        
                        $session_login = array(
                            "id_user"	=> $result->id,
                            "username"	=> $result->username,
                            "nama"		=> $result->nama,
                            "foto"		=> $result->foto,
                            "id_hak"	=> $result->id_hak_akses,
                            "hak_akses"	=> $result->hak_akses,
                            "is_admin"	=> $result->is_admin,
                        );
    
                        $this->session->set_userdata($session_login);
    
                        setcookie("bfmkey", 'f906512bba2a3f996a201f09d8d148be', time() + (86400 * 30), "/");
    
                        # return login berhasil
                        $back = true;
                        $note = 'Sukses Login';
                    } else {
                        # return password salah
                        $back = false;
                        $note = 'Username atau Password salah';
                    }
    
                    return $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));
                } else {
                    # form login dengan input username saja
                    return $this->output->set_content_type('text/html')->set_output($this->load->view(viewdir.'username', null, true));
                }
            } else {
                $valid 	= $this->form_validation->error_array();
                $back 	= false;
                $note 	= '';

                foreach ($valid as $key => $value) {
                    $note .= $value.'<br>';
                }

                return $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));
            }
        }
        
        $this->session->unset_userdata(array('id_user','username','nama'));
        $this->session->sess_destroy();

        setcookie("bfmkey", "", time() - 3600);
        $data['set'] = $this->model->get('settingan')->row();
        $this->load->view($this->admindir.'/login', $data);
    }
    
    public function form($view=null)
    {
        $usernameSes = $this->session->userdata('username');

        if (!empty($usernameSes)) {
            return $this->output->set_content_type('text/html')->set_output($this->load->view(viewdir.'password', null, true));
        } else {
            return $this->output->set_content_type('text/html')->set_output($this->load->view(viewdir.'username', null, true));
        }
    }

    public function out()
    {
        $this->session->unset_userdata(array('id_user','username','nama'));

        $this->session->sess_destroy();

        setcookie("bfmkey", "", time() - 3600);

        redirect(base_url($this->admindir.'/login'));
    }

    public function profil()
    {
        $data = array(
            'data' => $this->model->get('user', null, array('id'=>$this->session->userdata('id_user')))->row(),
        );

        $this->load->view($this->admindir.'/login/profil', $data);
    }

    public function action()
    {
        $back = null;
        $note = null;
        $post = $_POST;
        
        $this->form_validation->set_rules('nama', 'Nama Lengkap', 'required');

        if (!empty($post['password'])) {
            $this->form_validation->set_rules('password', 'Password', 'required|min_length[6]');
            $this->form_validation->set_rules('konfirmasi_password', 'Konfirmasi Password', 'required|matches[password]');
        }

        if ($this->form_validation->run()) {
            if (isset($post['password'])) {
                $post['password'] = md5($post['password']);
            } else {
                unset($post['password']);
            }
            unset($post['konfirmasi_password']);

            $back = $this->model->update('user', $post, array('id'=>$this->session->userdata('id_user')));

            if (!$back) {
                $title = 'Gagal.';
                $note  = 'Kesalahan server silahkan coba lagi.';
            } else {
                $title = '';
                $note  = 'Sukses update data profil user.'; // <br/><a href="'.base_url($_SERVER['REQUEST_URI']).'">Klik disini untuk reload sekarang</a>
            }
        } else {
            $valid = $this->form_validation->error_array();
            $note = '';

            foreach ($valid as $key => $value) {
                $note .= $value.'<br>';
            }

            $back = false;
            $title = 'Gagal Validasi.';
        }
            
        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

        return;
    }
}
