<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Opname extends ADMIN_Controller {

	public function __construct() {
		parent::__construct();
		define('part', $this->admindir.'/laporan/opname/');
		$this->load->model('LaporanModel', 'laporan');

		$arr  = $this->config->item('menu');
		$menu = $this->aksesmenu->search_menu($arr, 'href', '/laporan/opname');
		$this->menu = $menu[0]['id'];
	}

	public function index() {
		$this->aksesmenu->isAkses($this->menu);

		$this->template->display(part.'data');
	}

	public function listdata($page=1) {
		$where = array();
		$pag_filter = '';

		if (isset($_POST['filter'])) {
			$filter = $_POST['filter'];

			$pag_filter .= '{';

            if (!empty($filter['bulan'])) {
                $where['bulan'] = $filter['bulan'];

                $pag_filter .= "bulan: '".$filter['bulan']."',";
            }

			if (!empty($filter['tahun'])) {
				$where['tahun'] = $filter['tahun'];

				$pag_filter .= "tahun: '".$filter['tahun']."',";
			}

			if (!empty($filter['barang'])) {
				$where['barang'] = $filter['barang'];

				$pag_filter .= "barang: '".$filter['barang']."'";
			}

			$pag_filter .= '}';
		}

		$limit  = empty($_POST['limit']) ? 20 : $_POST['limit'];
		$offset = ($limit * $page) - $limit;

		$paging = array(
				'url'		=> '/laporan/opname/listdata/',
				'filter'	=> $pag_filter,
		        'limit' 	=> $limit,
		        'count_row' => $this->laporan->getCountOpname($where),
		        'current' 	=> $page
			);

        $paging['list'] = gen_paging($paging);

        $data = array(
				'BarangFind' => isset($where['barang']) ? $where['barang'] : '',
				'bulanFind'	 => isset($where['bulan']) ? $where['bulan'] : date('m'),
				'tahunFind'	 => isset($where['tahun']) ? $where['tahun'] : date('Y'),
				'BulanOption'=> $this->getPilihBulan(),
        		'list'	   	 => $this->laporan->getPagingOpname($where, $limit, $offset),
        		'limit'   	 => $limit,
        		'paging'   	 => $paging
        	);

		$this->load->view(part.'list', $data);
	}

	public function close() {
		$post = $this->input->post();
		
		$back = $this->laporan->Kalkulasi($post);

		$note = $back ? 'Berhasil' : 'Gagal';
		$note = $note . ' proses kalkulasi stok bulan '.date_show_month($post['bulan']);

		$this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));

		return;
	}

	public function cetak($bulan = null, $tahun = null, $barang = null) {
		$where = null;

		if (isset($barang)) {
			$where['barang'] = $barang;
		}

		if (isset($bulan)) {
			$where['bulan'] = $bulan;
		}
		else {
			$where['bulan'] = date('m');
		}

		if (isset($tahun)) {
			$where['tahun'] = $tahun;
		}
		else {
			$where['tahun'] = date('Y');
		}

		$data['list'] = $this->laporan->getPagingOpname($where);

		$this->load->view(part.'cetak', $data);
	}
}