<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Stok extends ADMIN_Controller {

	public function __construct() {
		parent::__construct();
		define('part', $this->admindir.'/laporan/stok/');
		$this->load->model('LaporanModel', 'laporan');

		$arr  = $this->config->item('menu');
		$menu = $this->aksesmenu->search_menu($arr, 'href', '/laporan/stok');
		$this->menu = $menu[0]['id'];
	}

	public function index() {
		$this->aksesmenu->isAkses($this->menu);

		$this->template->display(part.'data');
	}

	public function listdata($page=1) {
		$where = array();
		$pag_filter = '';

        $date = new DateTime('now');
		$date->modify('last day of this month');
		$mntbf = (date('m') < 2) ? '01' : date('m')-1;
		$month = date('01-'.$mntbf.'-Y').' s/d '.$date->format('d-m-Y');

		if (isset($_POST['filter'])) {
			$filter = $_POST['filter'];

			$pag_filter .= '{';

			if (!empty($filter['barang'])) {
				$where['barang'] = $filter['barang'];

				$pag_filter .= "barang: '".$filter['barang']."'";
			}

			if (!empty($filter['kategori'])) {
				$where['kategori'] = $filter['kategori'];

				$pag_filter .= "kategori: '".$filter['kategori']."'";
			}

			if (!empty($filter['merk'])) {
				$where['merk'] = $filter['merk'];

				$pag_filter .= "merk: '".$filter['merk']."'";
			}

			$pag_filter .= '}';
		}

		$limit  = empty($_POST['limit']) ? 20 : $_POST['limit'];
		$offset = ($limit * $page) - $limit;

		$paging = array(
				'url'		=> '/laporan/stok/listdata/',
				'filter'	=> $pag_filter,
		        'limit' 	=> $limit,
		        'count_row' => $this->laporan->getCountStok($where),
		        'current' 	=> $page
			);

        $paging['list'] = gen_paging($paging);

        $data = array(
				'BarangFind' 	=> isset($where['barang']) ? $where['barang'] : '',
				'KategoriFind' 	=> isset($where['kategori']) ? $where['kategori'] : '',
				'MerkFind' 	=> isset($where['merk']) ? $where['merk'] : '',
				'KategoriOption' => $this->getKategori('[ Semua ]'),
				'MerkOption' => $this->getMerk('[ Semua ]'),
        		'list'	   	=> $this->laporan->getPagingStok($where, $limit, $offset),
        		'limit'   	=> $limit,
        		'paging'   	=> $paging
        	);

		$this->load->view(part.'list', $data);
	}

	public function cetak($barang = null, $kategori = null, $merk = null) {
		$where = null;
		if (!empty($barang) && $barang != 'null') {
			$where['barang'] = $barang;
		}

		if (!empty($kategori) && $kategori != 'null') {
			$where['kategori'] = $kategori;
		}

		if (!empty($merk) && $merk != 'null') {
			$where['merk'] = $merk;
		}

		$data['list'] = $this->laporan->getPagingStok($where);

		$this->load->view(part.'cetak', $data);
	}
}