<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Barang extends ADMIN_Controller {

	public function __construct() {
		parent::__construct();
		define('part', $this->admindir.'/master/barang/');
		$this->load->model('BarangModel', 'barang');

		$arr  = $this->config->item('menu');
		$menu = $this->aksesmenu->search_menu($arr, 'href', '/master/barang');
		$this->menu = $menu[0]['id'];
	}

	public function index() {
		$this->aksesmenu->isAkses($this->menu);

		$this->template->display(part.'data');
	}

	public function listdata($page=1) {
		$where = array();
		$pag_filter = '';

		if (isset($_POST['filter'])) {
			$filter = $_POST['filter'];

			$pag_filter .= '{';

			if (!empty($filter['barang'])) {
				$where['barang'] = $filter['barang'];

				$pag_filter .= "barang: '".$filter['barang']."'";
			}

			if (!empty($filter['kategori'])) {
				$where['kategori'] = $filter['kategori'];

				$pag_filter .= "kategori: '".$filter['kategori']."'";
			}

			if (!empty($filter['merk'])) {
				$where['merk'] = $filter['merk'];

				$pag_filter .= "merk: '".$filter['merk']."'";
			}

			$pag_filter .= '}';
		}

		$limit  = empty($_POST['limit']) ? 5 : $_POST['limit'];
		$offset = ($limit * $page) - $limit;

		$paging = array(
				'url'		=> '/master/barang/listdata/',
				'filter'	=> $pag_filter,
		        'limit' 	=> $limit,
		        'count_row' => $this->barang->getCount($where),
		        'current' 	=> $page
			);

        $paging['list'] = gen_paging($paging);

        $data = array(
				'BarangFind' 	=> isset($where['barang']) ? $where['barang'] : '',
				'KategoriFind' 	=> isset($where['kategori']) ? $where['kategori'] : '',
				'MerkFind' 	=> isset($where['merk']) ? $where['merk'] : '',
				'KategoriOption' => $this->getKategori('[ Semua ]'),
				'MerkOption' => $this->getMerk('[ Semua ]'),
        		'list'	   	=> $this->barang->getPagingBarang($where, $limit, $offset),
        		'ak_add'	=> $this->aksesmenu->cekAksi($this->menu, '1'),
        		'ak_upd'	=> $this->aksesmenu->cekAksi($this->menu, '2'),
        		'ak_del'	=> $this->aksesmenu->cekAksi($this->menu, '3'),
        		'limit'   	=> $limit,
        		'paging'   	=> $paging
        	);

		$this->load->view(part.'list', $data);
	}

	public function add() {
		$this->aksesmenu->isTambah($this->menu);

		$data = array(
			'JenisOption' => $this->getKategori('Pilih Jenis'),
			'MerkOption' => $this->getMerk('Pilih Merk')
			);

		$this->load->view(part.'form', $data);
	}

	public function edit($id) {
		$this->aksesmenu->isUbah($this->menu);

		$data = array(
			'data' => $this->model->get('barang', null, array('id'=>$id))->row(),
			'JenisOption' => $this->getKategori('Pilih Jenis'),
			'MerkOption' => $this->getMerk('Pilih Merk')
			);

		$this->load->view(part.'form', $data);
	}

	public function delete($id) {
		// $back = $this->model->delete('barang', array('id'=>$id));
		$back = $this->model->update('barang', array('is_delete'=>'true'), array('id'=>$id));

		if (!$back) {
			$note = 'Server gagal hapus data';
		}
		else {
			$note = 'Sukses hapus data';
		}

		$this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));

		return;
	}

	public function action(){
		$back = null;
		$note = null;
		$id   = null;
		$post = $_POST;

		$this->form_validation->set_rules('nama', 'Nama Barang','required');
		$this->form_validation->set_rules('id_kategori', 'Jenis','required');
		$this->form_validation->set_rules('id_merk', 'Merk','required');

		if ($this->form_validation->run()) {
			if (isset($post['id'])) {
				$id = $post['id']; 
				unset($post['id']);

				$back = $this->model->update('barang', $post, array('id'=>$id));
			}
			else {
				$back = $this->model->save('barang', $post);
			}

			if (empty($msg)) {
				$msg = (isset($id)) ? 'edit' : 'simpan';
			}

			if (!$back) {
				$title = 'Gagal.';
				$note = $msg;
			}
			else {
				$title = '';
				$note  = 'Sukses '.$msg.' data';
			}
		}
		else {
			$valid = $this->form_validation->error_array();
			$note = '';

			foreach ($valid as $key => $value) {
				$note .= $value.'<br>';
			}

			$back = FALSE;
			$title = 'Gagal Validasi.';
		}

		$this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

		return;
	}
}
