<?php
defined('BASEPATH') or exit('No direct script access allowed');

class User extends ADMIN_Controller
{
    public function __construct()
    {
        parent::__construct();
        define('part', $this->admindir.'/master/user/');
        $this->load->model('UserModel', 'user');

        $arr  = $this->config->item('menu');
        $menu = $this->aksesmenu->search_menu($arr, 'href', '/master/user');
        $this->menu = $menu[0]['id'];
    }

    public function index()
    {
        $this->aksesmenu->isAkses($this->menu);

        $this->template->display(part.'data');
    }

    public function listdata($page=1)
    {
        $where = array();
        $pag_filter = '';

        if (isset($_POST['filter'])) {
            $filter = $_POST['filter'];

            $pag_filter .= '{';

            if (isset($filter['nama'])) {
                $where['nama'] = $filter['nama'];

                $pag_filter .= "nama: '".$filter['nama']."'";
            }

            $pag_filter .= '}';
        }

        $limit  = empty($_POST['limit']) ? 5 : $_POST['limit'];
        $offset = ($limit * $page) - $limit;

        $paging = array(
                'url'		=> '/master/user/listdata/',
                'count_row' => $this->user->getCount($where),
                'filter'	=> $pag_filter,
                'limit' 	=> $limit,
                'current' 	=> $page
            );

        $paging['list'] = gen_paging($paging);

        $data = array(
                'namaFind' 	=> isset($where['nama']) ? $where['nama'] : '',
                'list'	   	=> $this->user->getPagingUser($where, $limit, $offset),
                'ak_add'	=> $this->aksesmenu->cekAksi($this->menu, '1'),
                'ak_upd'	=> $this->aksesmenu->cekAksi($this->menu, '2'),
                'ak_del'	=> $this->aksesmenu->cekAksi($this->menu, '3'),
                'limit'   	=> $limit,
                'paging'   	=> $paging
            );

        $this->load->view(part.'list', $data);
    }

    public function add()
    {
        $this->aksesmenu->isTambah($this->menu);

        $data = array(
                'HakOption' => $this->pilihHakAkses('Pilih Hak Akses')
            );

        $this->load->view(part.'form', $data);
    }

    public function edit($id)
    {
        $this->aksesmenu->isUbah($this->menu);

        $data = array(
            'data' => $this->model->get('user', null, array('id'=>$id))->row(),
            'HakOption' => $this->pilihHakAkses('Pilih Hak Akses'),
        );

        $this->load->view(part.'form', $data);
    }

    public function delete($id)
    {
        $this->aksesmenu->isHapus($this->menu);

        $back = $this->model->delete('user', array('id'=>$id));

        if (!$back) {
            $note = 'Server gagal hapus data';
        } else {
            $note = 'Sukses hapus data';
        }

        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));

        return;
    }

    public function action()
    {
        $id   = null;
        $back = null;
        $note = null;
        $post = $_POST;

        $this->form_validation->set_rules('nama', 'Nama Lengkap', 'required');
        $this->form_validation->set_rules('username', 'Username', 'required');
        $this->form_validation->set_rules('id_hak_akses', 'Hak Akses', 'required');

        if (empty($post['id'])) {
            $this->form_validation->set_rules('password', 'Password', 'required');
        }

        if ($this->form_validation->run()) {
            if (!empty($post['foto'])) {
              $post['foto'] = str_replace('/upload/', '', $post['foto']);
              $post['foto'] = !empty($post['foto']) ? '/upload/'.$post['foto'] : '';
            }
            
            if (isset($post['id'])) {
                $id = $post['id'];

                unset($post['id']);

                $cek = $this->model->get('user', 'username', array('id !='=>$id,'username'=>$post['username']))->row();

                if (!empty($cek)) {
                    $back = false;
                    $msg  = 'Username sudah ada, coba yg lain';
                } else {
                    if (isset($post['password'])) {
                        $post['password'] = md5($post['password']);
                    } else {
                        unset($post['password']);
                    }

                    $back = $this->model->update('user', $post, array('id'=>$id));
                }
            } else {
                $cek = $this->model->get('user', 'username', array('username'=>$post['username']))->row();

                if (!empty($cek)) {
                    $back = false;
                    $msg  = 'Username sudah ada, coba yg lain';
                } else {
                    $post['password'] = md5($post['password']);

                    $newid = $this->IdPlus('user', 'id');
                    $post['id'] = $newid;

                    $back = $this->model->save('user', $post);
                }
            }

            if (empty($msg)) {
                $msg = (isset($id)) ? 'edit <br>Jika gambar tidak berubah coba reload' : 'simpan';
            }

            if (!$back) {
                $title = 'Gagal.';
                $note = $msg;
            } else {
                $title = '';
                $note  = 'Sukses '.$msg.' data';
            }
        } else {
            $valid = $this->form_validation->error_array();
            $note = '';

            foreach ($valid as $key => $value) {
                $note .= $value.'<br>';
            }

            $back = false;
            $title = 'Gagal Validasi.';
        }

        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

        return;
    }
}
