<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Keluar extends ADMIN_Controller {

	public function __construct() {
		parent::__construct();
		define('part', $this->admindir.'/proses/keluar/');
		$this->load->model('KeluarModel', 'keluar');

		$arr  = $this->config->item('menu');
		$menu = $this->aksesmenu->search_menu($arr, 'href', '/proses/keluar');
		$this->menu = $menu[0]['id'];
	}

	public function index() {
		$this->aksesmenu->isAkses($this->menu);

		$this->template->display(part.'data');
	}

	public function listdata($page=1) {
		$where = array();
		$pag_filter = '';

        $date = new DateTime('now');
		$date->modify('last day of this month');
		$mntbf = (date('m') < 2) ? '01' : date('m')-1;
		$month = date('01-'.$mntbf.'-Y').' s/d '.$date->format('d-m-Y');

		if (isset($_POST['filter'])) {
			$filter = $_POST['filter'];

			$pag_filter .= '{';

            if (isset($filter['nomor'])) {
                $where['nomor'] = $filter['nomor'];

                $pag_filter .= "nomor: '".$filter['nomor']."'";
            }

			if (isset($filter['barang'])) {
				$where['barang'] = $filter['barang'];

				$pag_filter .= "barang: '".$filter['barang']."'";
			}

			if (isset($filter['petugas'])) {
				$where['petugas'] = $filter['petugas'];

				$pag_filter .= "petugas: '".$filter['petugas']."'";
			}

			if (isset($filter['kategori'])) {
				$where['kategori'] = $filter['kategori'];

				$pag_filter .= "kategori: '".$filter['kategori']."'";
			}

			if (isset($filter['tanggal'])) {
				$where['tanggal'] = $filter['tanggal'];

				$pag_filter .= "tanggal: '".$filter['tanggal']."'";
			}

			$pag_filter .= '}';
		}

		$limit  = empty($_POST['limit']) ? 5 : $_POST['limit'];
		$offset = ($limit * $page) - $limit;

		$paging = array(
				'url'		=> '/proses/keluar/listdata/',
				'filter'	=> $pag_filter,
		        'limit' 	=> $limit,
		        'count_row' => $this->keluar->getCount($where),
		        'current' 	=> $page
			);

        $paging['list'] = gen_paging($paging);

        $data = array(
				'tglFind' 		=> isset($where['tanggal']) ? $where['tanggal'] : $month,
				'NomorFind' 	=> isset($where['nomor']) ? $where['nomor'] : '',
				'BarangFind' 	=> isset($where['barang']) ? $where['barang'] : '',
				'PetugasFind' 	=> isset($where['petugas']) ? $where['petugas'] : '',
				'KategoriFind' 	=> isset($where['kategori']) ? $where['kategori'] : '',
				'KategoriOption' => $this->getKategori('[ Semua ]'),
        		'list'	   	=> $this->keluar->getPaging($where, $limit, $offset),
        		'ak_add'	=> $this->aksesmenu->cekAksi($this->menu, '1'),
        		'ak_upd'	=> $this->aksesmenu->cekAksi($this->menu, '2'),
        		'ak_del'	=> $this->aksesmenu->cekAksi($this->menu, '3'),
        		'limit'   	=> $limit,
        		'paging'   	=> $paging
        	);

		$this->load->view(part.'list', $data);
	}

	public function add() {
		$this->aksesmenu->isTambah($this->menu);

		$data = array(
				'CustomerOption' => $this->getCustomer('Pilih Customer'),
				'BarangOption' => $this->getBarang('Pilih Barang', 'merk', array('stok >' => 0)),
        		'userSes' => $this->getIdentitasUser($this->session->userdata('id_user')),
        		'newNomor' => $this->newNomor('keluar', 'no_surat', 'SJ-')
			);

		$this->load->view(part.'form', $data);
	}

	public function edit($id) {
		$this->aksesmenu->isUbah($this->menu);

		$data = array(
					'data' => $this->model->get('keluar', null, array('id'=>$id))->row(),
					'CustomerOption' => $this->getCustomer('Pilih Customer'),
					'BarangOption' => $this->getBarang('Pilih Barang', 'merk', array('stok >' => 0)),
            'userSes' => $this->getIdentitasUser($this->session->userdata('id_user')),
            'newNomor' => $this->newNomor('keluar', 'no_surat', 'SJ-')
			);

		$this->load->view(part.'form', $data);
	}

	public function delete($id) {
		$back = $this->model->delete('keluar_list', array('id_keluar'=>$id));
		$back = $this->model->delete('keluar', array('id'=>$id));

		if (!$back) {
			$note = 'Server gagal hapus data';
		}
		else {
			$note = 'Sukses hapus data';
		}

		$this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));

		return;
	}

	public function action(){
		$back = null;
		$note = null;
		$id   = null;
		$post = $_POST;

		$_POST['barang'] = !empty($post['id_barang']) ? 1 : null;

		$this->form_validation->set_rules('id_customer', 'Customer','required');
		$this->form_validation->set_rules('barang', 'Barang','required');
		$this->form_validation->set_rules('waktu', 'Tanggal','required');
		$this->form_validation->set_rules('pengirim', 'Pengirim','required');

		if ($this->form_validation->run()) {
            $post['no_surat'] = $this->newNomor('keluar', 'no_surat', 'SJ-');

			$back = $this->keluar->save($post);

			if (empty($msg)) {
				$msg = (isset($id)) ? 'edit' : 'simpan';
			}

			if (!$back) {
				$title = 'Gagal.';
				$note = $msg;
			}
			else {
				$title = '';
				$note  = 'Sukses '.$msg.' data';
			}
		}
		else {
			$valid = $this->form_validation->error_array();
			$note = '';

			foreach ($valid as $key => $value) {
				$note .= $value.'<br>';
			}

			$back = FALSE;
			$title = 'Gagal Validasi.';
		}

		$this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

		return;
    }

    public function stok() {
        $id = $this->input->post('brg');

        $stok = $this->master->get('barang', 'stok', array('id' => $id))->row('stok');

        $this->output->set_content_type('application/json')->set_output(json_encode(array('stok'=>$stok)));

		return;
    }
}
