<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Akses extends ADMIN_Controller
{
    public function __construct()
    {
        parent::__construct();
        define('part', $this->admindir.'/setting/akses/');
        $this->load->model('SettingModel', 'set');

        $arr  = $this->config->item('menu');
        $menu = $this->aksesmenu->search_menu($arr, 'href', '/setting/akses');
        $this->menu = $menu[0]['id'];
    }

    public function index()
    {
        $this->aksesmenu->isAkses($this->menu);
        
        $this->template->display(part.'data');
    }

    public function listdata($page=1)
    {
        $where = array();
        $pag_filter = '';

        if (isset($_POST['filter'])) {
            $filter = $_POST['filter'];

            $pag_filter .= '{';
            $pag_filter .= '}';
        }
        
        $limit  = empty($_POST['limit']) ? 5 : $_POST['limit'];
        $offset = ($limit * $page) - $limit;
        
        $paging = array(
                'url'		=> '/setting/akses/listdata/',
                'filter'	=> $pag_filter,
                'limit' 	=> $limit,
                'count_row' => $this->set->getCountAkses($where),
                'current' 	=> $page
            );

        $paging['list'] = gen_paging($paging);

        $data = array(
                'list'	   	=> $this->set->getPagingAkses($where, $limit, $offset),
                'ak_add'	=> $this->aksesmenu->cekAksi($this->menu, '1'),
                'ak_upd'	=> $this->aksesmenu->cekAksi($this->menu, '2'),
                'ak_del'	=> $this->aksesmenu->cekAksi($this->menu, '3'),
                'limit'  	=> $limit,
                'paging'   	=> $paging
            );
        
        $this->load->view(part.'list', $data);
    }

    public function add()
    {
        $this->aksesmenu->isTambah($this->menu);
        
        $this->load->view(part.'form');
    }

    public function edit($id)
    {
        $this->aksesmenu->isUbah($this->menu);
        
        $data['data'] = $this->model->get('hak_akses', null, array('id'=>$id))->row();

        $this->load->view(part.'form', $data);
    }

    public function set($id)
    {
        $data = array(
            'data' => $this->model->get('hak_akses', null, array('id'=>$id))->row(),
            'cek' => $this->set->getAksesMenu($id)->result(),
            'menu' => $this->config->item('menu')
            );

        $this->load->view(part.'set', $data);
    }

    public function delete($id)
    {
        $back = $this->model->delete('hak_akses', array('id'=>$id));

        if (!$back) {
            $note = 'Server gagal hapus data';
        } else {
            $note = 'Sukses hapus data';
        }

        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'note'=>$note)));

        return;
    }
        
    public function action()
    {
        $back = null;
        $note = null;
        $id   = null;
        $post = $_POST;

        $this->form_validation->set_rules('hak_akses', 'Nama Hak Akses', 'required');
        
        if ($this->form_validation->run()) {
            $post['is_admin'] = empty($post['is_admin']) ? '0' : '1';

            if (isset($post['id'])) {
                $id = $post['id'];

                unset($post['id']);

                $back = $this->model->update('hak_akses', $post, array('id'=>$id));
            } else {
                $back = $this->model->save('hak_akses', $post);
            }

            if (empty($msg)) {
                $msg = (isset($id)) ? 'edit' : 'simpan';
            }

            if (!$back) {
                $title = 'Gagal.';
                $note = $msg;
            } else {
                $title = '';
                $note  = 'Sukses '.$msg.' data';
            }
        } else {
            $valid = $this->form_validation->error_array();
            $note = '';

            foreach ($valid as $key => $value) {
                $note .= $value.'<br>';
            }

            $back = false;
            $title = 'Gagal Validasi.';
        }
            
        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

        return;
    }

    public function setAkses()
    {
        $back = null;
        $note = null;
        $post = $_POST;

        $menu = array();
        foreach ($post['aksi'] as $k => $val) {
            $id_hak_akses = $k;

            $cek_menu = $post['aksi'][$k];

            foreach ($cek_menu as $x => $aksi) {
                $id_menu = $x;
                    
                $menu[] = array(
                    'id_hak_akses' => $id_hak_akses,
                    'id_menu' => $id_menu,
                    'aksi' => $aksi,
                );
            }
        }

        $back = $this->set->saveAkses($menu);

        if (!$back) {
            $title = 'Gagal.';
            $note = 'Server gagal, coba lagi';
        } else {
            $title = '';
            $note  = 'Sukses setting akses';
        }

        $this->output->set_content_type('application/json')->set_output(json_encode(array('result'=>$back, 'title'=>$title, 'note'=>$note)));

        return;
    }
}
