<?php defined('BASEPATH') or die('No direct access allowed.');

class Aksesmenu {

	var $ci = NULL;
	public function __construct()
	{
		$this->ci = &get_instance();
		$this->ci->load->model('MasterModel', 'master');
	}

	public function cekAkses() {
		if ($this->ci->input->is_ajax_request()) {
			$url = explode('?', $_SERVER['REQUEST_URI']);
			$url = substr($url[0], 1);
		}
		else {
			$url = $_SERVER['REQUEST_URI'];
		}
	
		if (!$this->isAkses($url)) {
			redirect('/forbidden');
		}
	}

	public function isAkses($id_menu) {
		if (!empty($id_menu)) {
			$cek = $this->ci->master->get('akses_menu', '*',array('id_hak_akses'=>$this->ci->session->userdata('id_hak'), 'id_menu'=>$id_menu, 'aksi'=>'0'))->row();

			$ret = (!empty($cek) || !empty($this->ci->session->userdata('is_admin'))) ? true : false;
		}
		else{
			$ret = false;
		}

		if (!$ret) {
			redirect('/forbidden');
		}

		return $ret;
	}

	public function isTambah($id_menu) {
		if (!empty($id_menu)) {
			$cek = $this->ci->master->get('akses_menu', '*',array('id_hak_akses'=>$this->ci->session->userdata('id_hak'), 'id_menu'=>$id_menu, 'aksi'=>'1'))->row();

			$ret = (!empty($cek) || !empty($this->ci->session->userdata('is_admin'))) ? true : false;
		}
		else{
			$ret = false;
		}

		if (!$ret) {
			redirect('/forbidden');
		}

		return $ret;
	}

	public function isUbah($id_menu) {
		if (!empty($id_menu)) {
			$cek = $this->ci->master->get('akses_menu', '*',array('id_hak_akses'=>$this->ci->session->userdata('id_hak'), 'id_menu'=>$id_menu, 'aksi'=>'2'))->row();

			$ret = (!empty($cek) || !empty($this->ci->session->userdata('is_admin'))) ? true : false;
		}
		else{
			$ret = false;
		}

		if (!$ret) {
			redirect('/forbidden');
		}

		return $ret;
	}

	public function isHapus($id_menu) {
		if (!empty($id_menu)) {
			$cek = $this->ci->master->get('akses_menu', '*',array('id_hak_akses'=>$this->ci->session->userdata('id_hak'), 'id_menu'=>$id_menu, 'aksi'=>'3'))->row();

			$ret = (!empty($cek) || !empty($this->ci->session->userdata('is_admin'))) ? true : false;
		}
		else{
			$ret = false;
		}

		if (!$ret) {
			redirect('/forbidden');
		}

		return $ret;
	}

	public function cekAksi($id_menu, $aksi) {
		if (!empty($id_menu)) {
			$cek = $this->ci->master->get('akses_menu', '*',array('id_hak_akses'=>$this->ci->session->userdata('id_hak'), 'id_menu'=>$id_menu, 'aksi'=>$aksi))->row();

			$ret = (!empty($cek) || !empty($this->ci->session->userdata('is_admin'))) ? true : false;
		}
		else{
			$ret = false;
		}
		
		return $ret;
	}

	public function search_menu($array, $key, $value) {
	    $results = array();

	    if (is_array($array)) {
	        if (isset($array[$key]) && $array[$key] == $value) {
	            $results[] = $array;
	        }

	        foreach ($array as $subarray) {
	            $results = array_merge($results, $this->search_menu($subarray, $key, $value));
	        }
	    }

	    return $results;
	}
}