<?php
defined('BASEPATH') or die('No direct script access allowed');

class KeluarModel extends CI_Model {

	public function __construct() {
		parent::__construct();
	}

	public function getCount($where=null) {
		if (isset($where)) {
			if (!empty($where['tanggal'])) {
				$tgl = explode('s/d', $where['tanggal']);

				$this->db->where(array('DATE(waktu) >='=>date_sql($tgl[0]), 'DATE(waktu) <='=>date_sql($tgl[1])));

				unset($where['tanggal']);
			}

			if (!empty($where['nomor'])) {
				$this->db->like('keluar.no_surat', $where['nomor'], 'both');

				unset($where['nomor']);
			}

			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');

				unset($where['barang']);
			}

			if (!empty($where['petugas'])) {
				$this->db->like('user.nama', $where['petugas'], 'both');

				unset($where['petugas']);
			}

			if (!empty($where['kategori'])) {
				$this->db->where('barang.id_kategori', $where['kategori']);

				unset($where['kategori']);
			}
		}

		$this->db->join('user', 'user.id = keluar.id_user', 'LEFT');
		$this->db->join('customer', 'customer.id = keluar.id_customer', 'LEFT');
		$this->db->join('keluar_list', 'keluar.id = keluar_list.id_keluar', 'LEFT');
		$this->db->join('barang', 'barang.id = keluar_list.id_barang', 'LEFT');
		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$query = $this->db->get('keluar');

		return $query->num_rows();

		$query->free_result();
	}

	public function getPaging($where=null, $limit=null, $offset=null, $order=null) {
		if (isset($where)) {
			if (!empty($where['tanggal'])) {
				$tgl = explode('s/d', $where['tanggal']);

				$this->db->where(array('DATE(waktu) >='=>date_sql($tgl[0]), 'DATE(waktu) <='=>date_sql($tgl[1])));

				unset($where['tanggal']);
			}

			if (!empty($where['nomor'])) {
				$this->db->like('keluar.no_surat', $where['nomor'], 'both');

				unset($where['nomor']);
			}

			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');

				unset($where['barang']);
			}

			if (!empty($where['petugas'])) {
				$this->db->like('user.nama', $where['petugas'], 'both');

				unset($where['petugas']);
			}

			if (!empty($where['kategori'])) {
				$this->db->where('barang.id_kategori', $where['kategori']);

				unset($where['kategori']);
			}

			$this->db->where($where);
		}

		if (isset($order))
			$this->db->order_by($order);
        else
            $this->db->order_by('id', 'desc');

        $this->db->join('user', 'user.id = keluar.id_user', 'LEFT');
				$this->db->join('customer', 'customer.id = keluar.id_customer', 'LEFT');
        $this->db->join('keluar_list', 'keluar.id = keluar_list.id_keluar', 'LEFT');
        $this->db->join('barang', 'barang.id = keluar_list.id_barang', 'LEFT');
        $this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
        $this->db->select('keluar.*, customer.nama as nama_customer, user.nama as nama_user, keluar_list.id_barang, barang.nama, kategori, merk, jumlah');

		if(!$limit && !$offset) {
			$query = $this->db->get('keluar');
		}
		else {
			$query = $this->db->get('keluar', $limit, $offset);
		}

		return $query;

		$query->free_result();
	}

	public function save($post) {
		$this->db->trans_begin();

		$postDB = array(
			'id_customer' => $post['id_customer'],
			'no_surat' => $post['no_surat'],
			'pengirim' => $post['pengirim'],
			'keterangan' => $post['keterangan'],
			'waktu' => date_sql($post['waktu']),
			'id_user' => $this->session->userdata('id_user')
		);

		$query = $this->model->save('keluar', $postDB);

		$id = $this->db->insert_id();

		$barangs = $post['id_barang'];

		foreach ($barangs as $key => $val) {
			$brg = $post['id_barang'][$key];
			$jml = $post['jumlah'][$key];

			$postList = array(
				'id_keluar' => $id,
				'id_barang' => $brg,
				'jumlah' => $jml,
			);

			$query = $this->model->save('keluar_list', $postList);

			$stok = $this->db->where('id', $brg)->get('barang')->row('stok');
			$newStok = $stok - $jml;

			$query = $this->db->where('id', $brg)->update('barang', array('stok'=>$newStok));

			// stok_history :
			$postHis = array('waktu'=>date('Y-m-d H:i:s'), 'id_ref'=>$id, 'jenis'=>'keluar', 'id_barang'=>$brg, 'jumlah'=>$jml, 'status'=>'min');
			$query = $this->model->save('stok_history', $postHis);
		}

		if ($this->db->trans_status() === FALSE)
			$this->db->trans_rollback();
		else
			$this->db->trans_commit();

		return $query;

		$query->free_result();
	}
}
