<?php
defined('BASEPATH') or die('No direct script access allowed');

class LaporanModel extends CI_Model {

	public function __construct() {
		parent::__construct();
	}

	public function getCountStok($where=null) {
		if (isset($where)) {
			if (!empty($where['kategori'])) {
				$this->db->where('barang.id_kategori', $where['kategori']);
				
				unset($where['kategori']);
			}
			
			if (!empty($where['merk'])) {
				$this->db->where('barang.id_merk', $where['merk']);
				
				unset($where['merk']);
			}

			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}
		}

		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$query = $this->db->get('barang');

		return $query->num_rows();

		$query->free_result();
	}

	public function getPagingStok($where=null, $limit=null, $offset=null, $order=null) {
		if (isset($where)) {
			if (!empty($where['kategori'])) {
				$this->db->where('barang.id_kategori', $where['kategori']);
				
				unset($where['kategori']);
			}
			
			if (!empty($where['merk'])) {
				$this->db->where('barang.id_merk', $where['merk']);
				
				unset($where['merk']);
			}
			
			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}
		}

		if (isset($order))
			$this->db->order_by($order);
		else
			$this->db->order_by('id', 'desc');

		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$this->db->select('barang.*, kategori, merk,
			(SELECT SUM(jumlah) FROM retur_list WHERE kondisi = "c" AND retur_list.id_barang = barang.id) as cacat
		');

		if(!$limit && !$offset) {
			$query = $this->db->get('barang');
		}
		else {
			$query = $this->db->get('barang', $limit, $offset);
		}

		return $query;

		$query->free_result();
	}

	public function getCountOpname($where=null) {
		if (isset($where)) {
			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}

			if (!empty($where['bulan'])) {
				// $this->db->where('stok_opname.bulan', $where['bulan']);
				
				unset($where['bulan']);
			}

			if (!empty($where['tahun'])) {
				// $this->db->where('stok_opname.tahun', $where['tahun']);
				
				unset($where['tahun']);
			}

			// $this->db->where($where);
		}

		$this->db->join('stok_opname', 'stok_opname.id_barang = barang.id', 'LEFT');
		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$query = $this->db->get('barang');

		return $query->num_rows();

		$query->free_result();
	}

	public function getPagingOpname($where=null, $limit=null, $offset=null, $order=null) {
		$bulan = date('m');
		$tahun = date('Y');

		if (isset($where)) {
			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}

			if (!empty($where['bulan'])) {
				// $this->db->where('stok_opname.bulan', $where['bulan']);
				$bulan = $where['bulan'];
				unset($where['bulan']);
			}

			if (!empty($where['tahun'])) {
				// $this->db->where('stok_opname.tahun', $where['tahun']);
				$tahun = $where['tahun'];
				unset($where['tahun']);
			}

			// $this->db->where($where);
		}

		if (isset($order))
			$this->db->order_by($order);
		else
			$this->db->order_by('id', 'desc');

		// periode stok awal
		if ($bulan == 1) {
			$bulanBefore = 12;
			$tahunBefore = $tahun - 1;
		} else {
			$bulanBefore = $bulan - 1;
			$tahunBefore = $tahun;
		}

		$period = "AND MONTH(waktu) = ".$bulan." AND YEAR(waktu) = ".$tahun;

		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->select('barang.*, kategori, merk,
			(SELECT stok_periode FROM stok_opname WHERE `stok_opname`.`id_barang` = `barang`.`id` AND bulan = '.$bulanBefore.' AND tahun = '.$tahunBefore.') as stok_awal,
			(SELECT SUM(jumlah) FROM masuk_list JOIN masuk ON masuk.id = masuk_list.id_masuk WHERE masuk_list.id_barang = barang.id '.$period.') as jum_masuk,
			(SELECT SUM(jumlah) FROM keluar_list JOIN keluar ON keluar.id = keluar_list.id_keluar WHERE keluar_list.id_barang = barang.id '.$period.') as jum_keluar
		');

		if(!$limit && !$offset) {
			$query = $this->db->get('barang');
		}
		else {
			$query = $this->db->get('barang', $limit, $offset);
		}

		return $query;

		$query->free_result();
	}

	public function Kalkulasi($post) {
		$bulan = $post['bulan'];
		$tahun = $post['tahun'];
		
		// periode stok awal
		if ($bulan == 1) {
			$bulanBefore = 12;
			$tahunBefore = $tahun - 1;
		} else {
			$bulanBefore = $bulan - 1;
			$tahunBefore = $tahun;
		}

		$datas = $this->db->get('barang')->result();

		if (!empty($datas)) {
			foreach ($datas as $key => $val) {
				$id_barang = $val->id;

				// hitung stok awal => bulan sebelumnya
				$stok_awal = $this->db->where(array('id_barang'=>$id_barang,'bulan'=>$bulanBefore, 'tahun'=>$tahunBefore))->get('stok_opname')->row('stok_periode');
				$stok_awal = isset($stok_awal) ? $stok_awal : 0;

				$period = array('id_barang'=>$id_barang,"MONTH(waktu)"=>$bulan, "YEAR(waktu)"=>$tahun);

				// hitung masuk
				$this->db->join('masuk', 'masuk.id = masuk_list.id_masuk', 'LEFT');
				$masuk = $this->db->select('SUM(jumlah) as jumlah')->where($period)->get('masuk_list')->row('jumlah');
				$masuk = isset($masuk) ? $masuk : 0;

				// hitung keluar
				$this->db->join('keluar', 'keluar.id = keluar_list.id_keluar', 'LEFT');
				$keluar = $this->db->select('SUM(jumlah) as jumlah')->where($period)->get('keluar_list')->row('jumlah');
				$keluar = isset($keluar) ? $keluar : 0;

				// hitung hasil
				$hasil = $stok_awal + $masuk - $keluar;

				// insert/update stok periode
				$where = array('id_barang'=>$id_barang,'bulan'=>$bulan, 'tahun'=>$tahun);

				$cek = $this->db->where($where)->get('stok_opname')->row();

				if (!empty($cek)) {
					$db = $this->db->where($where)->update('stok_opname', array('stok_periode'=>$hasil));
				} 
				else {
					$db = $this->db->insert('stok_opname', array('id_barang'=>$id_barang,'bulan'=>$bulan, 'tahun'=>$tahun, 'stok_periode'=>$hasil));
				}
			}
		}

		return $db;
	}
}
