<?php
defined('BASEPATH') or die('No direct script access allowed');

class MasterModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
    }
    
    public function get($table, $select=null, $where=null, $orderby=null, $orderon=null, $groupby=null, $limit=null)
    {
        if (isset($select)) {
            $this->db->select($select);
        } else {
            $this->db->select('*');
        }

        if (isset($where)) {
            $this->db->where($where);
        }

        if (isset($orderby)) {
            $orderon = isset($orderon) ? $orderon : 'ASC';

            $this->db->order_by($orderby, $orderon);
        }

        if (isset($groupby)) {
            $this->db->group_by($groupby);
        }
        
        if (isset($limit)) {
            return $this->db->get($table, $limit);
        } else {
            return $this->db->get($table);
        }
    }

    public function save($table, $post, $where=null)
    {
        if (isset($where)) {
            $this->db->where($where);
        }

        return $this->db->insert($table, $post);
    }
    
    public function update($table, $post, $where)
    {
        return $this->db->where($where)->update($table, $post);
    }
    
    public function delete($table, $where)
    {
        return $this->db->where($where)->delete($table);
    }

    public function newNomor($table, $field, $code, $where=null)
    {
        $lgCode = strlen($code);
        $subStr = $lgCode + 7; // [date(dmy) => 6 + 1]

        if (isset($where)) {
            $this->db->where($where);
        }
        
        $this->db->select('CAST(SUBSTRING('.$field.', '.$subStr.')AS SIGNED) AS thelast',FALSE);
        $this->db->order_by('thelast', 'DESC');
        $data = $this->db->get($table);

        $lastID = $data->row();
        $date = date('dmy');

        if (empty($lastID)) { 
            $lastID = '001';
        }
        else {
            $lastID = $lastID->thelast + 1;
            $lglastID = strlen($lastID);
            
            if ($lglastID == 2) { 
                $lenght = ($lglastID+1) - $lglastID;
            } 
            elseif ($lglastID < 2) { 
                $lenght = ($lglastID+2) - $lglastID;
            } 
            else  {
                $lenght = ($lglastID*1) - $lglastID;
            }

            $zero = str_repeat('0', $lenght);	 	 

            $lastID = $zero . $lastID;
        }
        
        $newNomor = $code . $date . $lastID;

        return $newNomor;    
    }

    public function countMasukHarian() {
        $this->db->where(array('DATE(waktu)'=>date('Y-m-d')));
        $this->db->join('masuk', 'masuk.id = masuk_list.id_masuk', 'LEFT');
        $query = $this->db->get('masuk_list');

        return $query->num_rows();
    }

    public function countKeluarHarian() {
        $this->db->where(array('DATE(waktu)'=>date('Y-m-d')));
        $this->db->join('keluar', 'keluar.id = keluar_list.id_keluar', 'LEFT');
        $query = $this->db->get('keluar_list');

        return $query->num_rows();
    }

    public function countReturHarian() {
        $this->db->where(array('DATE(waktu)'=>date('Y-m-d')));
        $this->db->join('retur', 'retur.id = retur_list.id_retur', 'LEFT');
        $query = $this->db->get('retur_list');

        return $query->num_rows();
    }

    public function countSum($type, $date) {
        $list = $type.'_list';

        $this->db->select('COUNT('.$type.'.id) as jumlah');
        $this->db->where(array('DATE(waktu)'=>$date));
        $this->db->join($type, $type.'.id = '.$list.'.id_'.$type, 'LEFT');
        $query = $this->db->get($list)->row('jumlah');

        return isset($query) ? ($query*1) : 0;
    }
}
