<?php
defined('BASEPATH') or die('No direct script access allowed');

class ReturModel extends CI_Model {

	public function __construct() {
		parent::__construct();
	}

	public function getCount($where=null) {
		if (isset($where)) {
			if (!empty($where['tanggal'])) {
				$tgl = explode('s/d', $where['tanggal']);

				$this->db->where(array('DATE(retur.waktu) >='=>date_sql($tgl[0]), 'DATE(retur.waktu) <='=>date_sql($tgl[1])));
				
				unset($where['tanggal']);
			}

			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}

			if (!empty($where['petugas'])) {
				$this->db->like('user.nama', $where['petugas'], 'both');
				
				unset($where['petugas']);
			}

			if (!empty($where['nomor'])) {
				$this->db->like('no_surat', $where['nomor'], 'both');
				
				unset($where['nomor']);
			}
		}

		$this->db->join('user', 'user.id = retur.id_user', 'LEFT');
        $this->db->join('keluar', 'keluar.id = retur.id_keluar', 'LEFT');
		$this->db->join('retur_list', 'retur.id = retur_list.id_retur', 'LEFT');
		$this->db->join('barang', 'barang.id = retur_list.id_barang', 'LEFT');
		$this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
		$query = $this->db->get('retur');

		return $query->num_rows();

		$query->free_result();
	}

	public function getPaging($where=null, $limit=null, $offset=null, $order=null) {
		if (isset($where)) {
			if (!empty($where['tanggal'])) {
				$tgl = explode('s/d', $where['tanggal']);

				$this->db->where(array('DATE(retur.waktu) >='=>date_sql($tgl[0]), 'DATE(retur.waktu) <='=>date_sql($tgl[1])));
				
				unset($where['tanggal']);
			}

			if (!empty($where['barang'])) {
				$this->db->like('barang.nama', $where['barang'], 'both');
				
				unset($where['barang']);
			}

			if (!empty($where['petugas'])) {
				$this->db->like('user.nama', $where['petugas'], 'both');
				
				unset($where['petugas']);
			}

			if (!empty($where['nomor'])) {
				$this->db->like('no_surat', $where['nomor'], 'both');
				
				unset($where['nomor']);
			}
		}

		if (isset($order))
			$this->db->order_by($order);
        else
            $this->db->order_by('id', 'desc');

        $this->db->join('user', 'user.id = retur.id_user', 'LEFT');
        $this->db->join('keluar', 'keluar.id = retur.id_keluar', 'LEFT');
        $this->db->join('retur_list', 'retur.id = retur_list.id_retur', 'LEFT');
        $this->db->join('barang', 'barang.id = retur_list.id_barang', 'LEFT');
        $this->db->join('kategori', 'kategori.id = barang.id_kategori', 'LEFT');
		$this->db->join('merk', 'merk.id = barang.id_merk', 'left');
        $this->db->select('retur.*, keluar.no_surat, kondisi, user.nama as nama_user, barang.nama, kategori, merk, jumlah');

		if(!$limit && !$offset) {
			$query = $this->db->get('retur');
		}
		else {
			$query = $this->db->get('retur', $limit, $offset);
		}

		return $query;

		$query->free_result();
	}

	public function save($post) {
		$this->db->trans_begin();

		$postDB = array(
			'id_keluar'	=> $post['id_keluar'],
			'keterangan'=> $post['keterangan'],
			'penerima'	=> $post['penerima'],
			'waktu' => date_sql($post['waktu']),
			'id_user' => $this->session->userdata('id_user')
		);

		$query = $this->model->save('retur', $postDB);

		$id = $this->db->insert_id();

		$barangs = $post['id_barang'];

		foreach ($barangs as $key => $val) {
			$brg = $post['id_barang'][$key];
			$jml = $post['jumlah'][$key];
			$kond = $post['kondisi'][$key];

			$postList = array(
				'id_retur' => $id,
				'id_barang' => $brg,
				'jumlah' => $jml,
				'kondisi' => $kond
			);

			$query = $this->model->save('retur_list', $postList);

			// tidak cacat kembali ke stok
			if ($kond == 't') { 
				$stok = $this->db->where('id', $brg)->get('barang')->row('stok');
				$newStok = $stok + $jml;
	
				$query = $this->db->where('id', $brg)->update('barang', array('stok'=>$newStok));

				// stok_history :
				$postHis = array('waktu'=>date('Y-m-d H:i:s'), 'id_ref'=>$id, 'jenis'=>'retur', 'id_barang'=>$brg, 'jumlah'=>$jml, 'status'=>'plus');
				$query = $this->model->save('stok_history', $postHis);
			}
		}

		if ($this->db->trans_status() === FALSE) 
			$this->db->trans_rollback();
		else
			$this->db->trans_commit();
		
		return $query;

		$query->free_result();
	}

	public function getCountKeluar($where=null) {
		if (isset($where)) {
			if (!empty($where['nomor'])) {
				$this->db->like('keluar.no_surat', $where['nomor'], 'both');
				
				unset($where['nomor']);
			}
		}

		$this->db->join('user', 'user.id = keluar.id_user', 'LEFT');
		$query = $this->db->get('keluar');

		return $query->num_rows();

		$query->free_result();
	}

	public function getPagingKeluar($where=null, $limit=null, $offset=null, $order=null) {
		if (isset($where)) {
			if (!empty($where['nomor'])) {
				$this->db->like('keluar.no_surat', $where['nomor'], 'both');
				
				unset($where['nomor']);
			}
		}

		if (isset($order))
			$this->db->order_by($order);
        else
            $this->db->order_by('id', 'desc');

        $this->db->join('user', 'user.id = keluar.id_user', 'LEFT');
        $this->db->select('keluar.*, user.nama as nama_user');

		if(!$limit && !$offset) {
			$query = $this->db->get('keluar');
		}
		else {
			$query = $this->db->get('keluar', $limit, $offset);
		}

		return $query;

		$query->free_result();
	}
}
