<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>

<script src="<?php echo base_url('assets/plugins/highcharts/highcharts.js'); ?>"></script>

<div class="box box-primary">
	<div class="box-header with-border">
		<i class="fa fa-home"></i>
		<h3 class="box-title">Dashboard</h3>
	</div>
	<div class="box-body" style="min-height: 425px;">
		<div class="row">
		<div class="col-lg-8 col-md-8 col-sm-12 col-xs-12">
			<h2 style="margin: 0;">Sistem Informasi Manajemen Inventori (SIMIven)</h2>
			<h4><?php echo $set->nama ?></h4>
			<span><?php echo $set->email ?></span>, <span><?php echo $set->telp ?></span><br>
			<span><?php echo $set->alamat ?></span>
		</div>
		<div class="col-lg-4 col-md-4 col-sm-12 col-xs-12">
			<p class="">
				<span class="mytimer"></span>, <span><?php echo date('d-m-Y') ?></span><br>
				<span>Login Sebagai : <?php echo ucwords($this->session->userdata('nama')) ?></span><br>
			</p>
		</div>
		</div>
		<br>

		<div class="row">
			<div class="col-lg-4 col-xs-4">
			<!-- small box -->
			<div class="small-box bg-aqua">
				<div class="inner text-center">
					<h3><?php echo ribuan($masuk); ?></h3>
					<p>Masuk hari ini</p>
				</div>
				<div class="icon"><i class="ion ion-bag"></i></div>
				<a href="<?php echo base_url('proses/masuk'); ?>" class="small-box-footer">More info <i class="fa fa-arrow-circle-right"></i></a>
			</div>
			</div>
			<!-- ./col -->
			<div class="col-lg-4 col-xs-4">
			<!-- small box -->
			<div class="small-box bg-green">
				<div class="inner text-center">
					<h3><?php echo ribuan($keluar); ?></h3>
					<p>Keluar hari ini</p>
				</div>
				<div class="icon"><i class="ion ion-stats-bars"></i></div>
				<a href="<?php echo base_url('proses/keluar'); ?>" class="small-box-footer">More info <i class="fa fa-arrow-circle-right"></i></a>
			</div>
			</div>
			<!-- ./col -->
			<div class="col-lg-4 col-xs-4">
			<!-- small box -->
			<div class="small-box bg-yellow">
				<div class="inner text-center">
					<h3><?php echo ribuan($retur); ?></h3>
					<p>Retur hari ini</p>
				</div>
				<div class="icon"><i class="ion ion-person-add"></i></div>
				<a href="<?php echo base_url('proses/retur'); ?>" class="small-box-footer">More info <i class="fa fa-arrow-circle-right"></i></a>
			</div>
			</div>
			<!-- ./col -->
		</div>
		<br>

		<div class="row">
			<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
			<div class="form-group">
				<label class="col-lg-1 col-md-1 col-sm-12 col-xs-12" for="tanggal">Periode : </label>
				<div class="input-group col-lg-4 col-md-4 col-sm-12 col-xs-12">
	              <div class="input-group-addon"><i class="fa fa-calendar"></i></div> 
	              <input type="text" name="tanggal" id="tanggal" value="<?php echo (isset($periode)) ? $periode : date('01-m-Y').' s/d '.date('d-m-Y') ?>" class="form-control" placeholder="Tanggal periode" readonly="readonly" style="background-color: #FFF;">
	            </div>
			</div>
			<div id="cart" style="max-width: 100%; height: auto; margin: 0 auto"></div>
			</div>
		</div>
	</div>
</div>

<script type="text/javascript">
	$(document).ready(function(){
		getdate();
		
		$('#tanggal').daterangepicker({
			cancelClass: 'btn-danger',
			showDropdowns: true,
			alwaysShowCalendars: true,
			showCustomRangeLabel: false,
			autoUpdateInput: false,
			locale: {
				format: 'DD-MM-YYYY',
				separator: ' s/d ',
				applyLabel: 'Ok',
				cancelLabel: 'Clear',
				daysOfWeek: ['Mg', 'Sn', 'Sl', 'Rb', 'Km', 'Jm','Sb'],
				monthNames: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
				firstDay: 0
			}
		}).on('apply.daterangepicker', function(ev, picker) {
			$(this).val(picker.startDate.format('DD-MM-YYYY') + ' s/d ' + picker.endDate.format('DD-MM-YYYY'));
			find();
		}).on('cancel.daterangepicker', function(ev, picker) {
			$(this).val('');
			find();
		});

        Highcharts.chart('cart', {
            chart: {
                type: 'column'
            },
            title: {
                text: 'Grafik Inventori Barang'
            },
            subtitle: {
                text: 'Periode : <?php echo $periode; ?>'
            },
            xAxis: {
                categories: <?php echo $labels; ?>,
                crosshair: true
            },
            yAxis: {
                min: 0,
                title: {
                    text: 'Jumlah Barang'
                }
            },
            tooltip: {
                headerFormat: '<span style="font-size:10px">{point.key}</span><table>',
                pointFormat: '<tr><td style="color:{series.color};padding:0">{series.name}: </td>' +
                    '<td style="padding:0"><b>{point.y:.1f} mm</b></td></tr>',
                footerFormat: '</table>',
                shared: true,
                useHTML: true
            },
            plotOptions: {
                column: {
                    pointPadding: 0.2,
                    borderWidth: 0
                }
            },
            series: [{
                name: 'Masuk',
                data: <?php echo $masuks; ?>

            }, {
                name: 'Keluar',
                data: <?php echo $keluars; ?>

            }, {
                name: 'Retur',
                data: <?php echo $returs; ?>

            }]
        });
    });

	function find() {
		let keyword = {
			tanggal: $('#tanggal').val()
		}

		pageLoad('/home/listdata/', 1, keyword, '.connectedSortable');
	}
</script>
