<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<?php $no = ($paging['limit']*$paging['current'])-$paging['limit']; ?>
	<div class="row">
		<div class="box-tools col-md-3 col-xs-12">
			<div class="btn-group" data-toggle="btn-toggle">
				<button type="button" class="btnRefresh btn btn-primary btn-sm"><i class="fa fa-refresh"></i> Refresh</button>
				&nbsp;&nbsp;
			</div>
			<?php if ($ak_add) : ?>
				<div class="btn-group" data-toggle="btn-toggle">
					<button type="button" class="btnAdd btn btn-success btn-sm"><i class="fa fa-plus-circle"></i> Tambah</button>
				</div>
			<?php endif; ?>
		</div>
		<div class="col-md-2 col-xs-12 pull-right">
			<select name='limit' id='limit' class="form-control input-sm col-sm-2 col-md-2 col-xs-2" onchange="pageLoad('/master/kategori/listdata/', 1)">
				<option <?php echo ($limit==5) ? 'selected' : '' ?> value='5'>Show 5 rows</option>
				<option <?php echo ($limit==20) ? 'selected' : '' ?> value='20'>Show 20 rows</option>
				<option <?php echo ($limit==50) ? 'selected' : '' ?> value='50'>Show 50 rows</option>
			</select>
		</div>
	</div>
	<div class="table-responsive">
		<table class="table table-striped table-bordered margin-top">
			<thead class="">
				<tr>
					<th width="5%">No</th>
					<th>Jenis</th>
					<th width="100px">Aksi</th>
				</tr>
			</thead>
			<thead>
				<tr>
					<th>&nbsp;</th>
					<th>&nbsp;</th>
					<th>&nbsp;</th>
				</tr>
			</thead>
			<tbody>
				<?php $no++; if($list->num_rows() > 0 ) : ?>
					<?php foreach ($list->result() as $key => $value): ?>
						<tr>
							<td><?php echo $no ?>.</td>
							<td><?php echo $value->kategori ?></td>
							<td align="center">
								<?php if ($ak_upd) : ?>
									<button title="Edit" data-id="<?php echo $value->id ?>" class="btnEdit btn btn-warning btn-xs" data-toggle="tooltip"><i class="fa fa-pencil"></i></button>&nbsp;
								<?php endif; ?>
								<?php if ($ak_del) : ?>
									<button title="Delete" data-id="<?php echo $value->id ?>" class="btnDelete btn btn-danger btn-xs" data-toggle="tooltip"><i class="fa fa-trash"></i></button>
								<?php endif; ?>
							</td>
						</tr>
					<?php $no++;  endforeach ?>
				<?php else : ?>
					<tr>
						<td colspan="4"><p>Data Kosong</p></td>
					</tr>
				<?php endif; ?>
			</tbody>
		</table>
		<input type='hidden' id='current' name='current' value='<?php echo $paging['current'] ?>'>
	</div>
	<div class='row'>
		<div class='col-sm-4 col-xs-12' style='margin-top:5px;margin-bottom:10px'>
			Total data <?php echo $paging['count_row'] ?> Rows
		</div>
		<div class='col-sm-8 col-xs-12 pull-right' style='margin-top:5px;margin-bottom:10px'>
			<?php echo $paging['list']; ?>
		</div>
	</div>

<script type="text/javascript">
	$(document).ready(function(){
    	$('.select-me').select2();
	});

	$('.btnAdd').click(function(){
		$.get(adminsite+"/master/kategori/add", function(content, status){
			BootstrapDialog.show({
				type: BootstrapDialog.TYPE_DEFAULT,
				title:  '<strong>Tambah jenis</strong>',
				message:$('<div></div>').append(content),
				buttons: [{
					label: 'Batal',
					cssClass: 'btn btn-danger',
					icon: 'fa fa-undo',
					action: function(dialog) {
						dialog.close();
					}
				},{
					label: 'Simpan',
					cssClass: 'btn btn-success',
					icon: 'fa fa-plus-circle',
					action: function(dialog) {
						dialog.enableButtons(false);
						dialog.setClosable(false);
						$.post(adminsite+"/master/kategori/action", $('#myform').serialize(), function(data, status){
							if (!data.result) {
								dialog.enableButtons(true);
            					toastr["error"](data.note, data.title);
							}
							else {
								toastr["success"](data.note, data.title);
								dialog.close();
								pageLoad('/master/kategori/listdata/',1);
							}
						});
					}
				}],
				onshown: function(dialog) {
					dialog.setClosable(false);
				}
			});
		});
	});

	$('.btnEdit').click(function() {
		$.get(adminsite+"/master/kategori/edit/"+$(this).data('id'), function(content, status){
			BootstrapDialog.show({
				type: BootstrapDialog.TYPE_DEFAULT,
				title:  '<strong>Edit jenis</strong>',
				message:$('<div></div>').append(content),
				buttons: [{
					label: 'Batal',
					cssClass: 'btn btn-danger',
					icon: 'fa fa-undo',
					action: function(dialog) {
						dialog.close();
					}
				},{
					label: 'Edit',
					cssClass: 'btn btn-success',
					icon: 'fa fa-pencil',
					action: function(dialog) {
						dialog.enableButtons(false);
						dialog.setClosable(false);
						$.post(adminsite+"/master/kategori/action", $('#myform').serialize(), function(data, status){
							if (!data.result) {
								dialog.enableButtons(true);
            					toastr["error"](data.note);
							}
							else {
								toastr["success"](data.note);
								dialog.close();
								pageLoad('/master/kategori/listdata/',1);
							}
						});
					}
				}],
				onshown: function(dialog) {
					dialog.setClosable(false);
				}
			});
		});
	});

	$('.btnDelete').click(function() {
		var id = $(this).data('id');

		$.confirm.show({
			"message":"Yakin Hapus Data?",
			"type":"danger",
			"yes":function(){
				$.get(adminsite+"/master/kategori/delete/"+id, function(content, status){
					if (!content.result) {
		        		toastr["error"](content.note);
						pageLoad('/master/kategori/listdata/',1);
					}
					else {
		        		toastr["success"](content.note);
						pageLoad('/master/kategori/listdata/',1);
					}
				});
			}
		});
	});

	$('#jeniskategoriFind').change(function() {
		find();
	});

	$('.btnRefresh').click(function() {
		pageLoad('/master/kategori/listdata/', 1);
	});

	function find () {
		var keyword = {jenis_kategori: $('#jeniskategoriFind').val()};

		pageLoad('/master/kategori/listdata/', 1, keyword);
	}
</script>
