<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<?php $no = ($paging['limit']*$paging['current'])-$paging['limit']; ?>
	<div class="row">
		<div class="box-tools col-md-3 col-xs-12">
			<div class="btn-group" data-toggle="btn-toggle">
				<button type="button" class="btnRefresh btn btn-primary btn-sm"><i class="fa fa-refresh"></i> Refresh</button>
				&nbsp;&nbsp;
			</div>
			<?php if ($ak_add) : ?>
				<div class="btn-group" data-toggle="btn-toggle">
					<button type="button" class="btnAdd btn btn-success btn-sm"><i class="fa fa-plus-circle"></i> Tambah</button>
				</div>
			<?php endif; ?>
		</div>
		<div class="col-md-2 col-xs-12 pull-right">
			<select name='limit' id='limit' class="form-control input-sm col-sm-2 col-md-2 col-xs-2" onchange="pageLoad('/proses/retur/listdata/', 1)">
				<option <?php echo ($limit==5) ? 'selected' : '' ?> value='5'>Show 5 rows</option>
				<option <?php echo ($limit==20) ? 'selected' : '' ?> value='20'>Show 20 rows</option>
				<option <?php echo ($limit==50) ? 'selected' : '' ?> value='50'>Show 50 rows</option>
			</select>
		</div>
	</div>
	<div class="table-responsive">
		<table class="table table-striped table-bordered margin-top">
			<thead class="">
				<tr>
					<th width="5%">No</th>
					<th>Tanggal Retur</th>
					<th>Nomor Surat Jalan</th>
					<th width="100">Keteragan</th>
					<th>Nama Barang</th>
					<th>Merk</th>
					<th>Jumlah</th>
					<th>Kondisi</th>
					<th>Petugas</th>
					<th>Penerima</th>
				</tr>
			</thead>
			<thead>
				<tr>
					<th>&nbsp;</th>
					<th>
						<div class="input-group">
			              <div class="input-group-addon"><i class="fa fa-calendar"></i></div>
			              <input type="text" id="TanggalFind" value="<?php echo (isset($tglFind)) ? $tglFind : '' ?>" class="form-control" placeholder="Pencarian Tanggal" readonly="readonly">
			            </div>
					</th>
					<th><input type="text" id="NomorFind" value="<?php echo $NomorFind ?>" class="form-control" placeholder="Ketik keyword lalu enter"></th>
					<th>&nbsp;</th>
					<th><input type="text" id="BarangFind" value="<?php echo $BarangFind ?>" class="form-control" placeholder="Ketik keyword lalu enter"></th>
					<th>&nbsp;</th>
					<th>&nbsp;</th>
					<th>&nbsp;</th>
					<th><input type="text" id="PetugasFind" value="<?php echo $PetugasFind ?>" class="form-control" placeholder="Ketik keyword lalu enter"></th>
					<th>&nbsp;</th>
				</tr>
			</thead>
			<tbody>
				<?php $no++; $total = 0; if($list->num_rows() > 0 ) : ?>
					<?php foreach ($list->result() as $key => $value): ?>
						<tr>
							<td><?php echo $no ?>.</td>
							<td align="right"><?php echo date_show($value->waktu) ?></td>
							<td><?php echo $value->no_surat ?></td>
							<td><?php echo $value->keterangan ?></td>
							<td><?php echo $value->nama ?></td>
							<td><?php echo $value->merk ?></td>
							<td align="center"><?php echo ribuan($value->jumlah) ?></td>
							<td><?php echo ($value->kondisi=='c') ? 'Cacat' : 'Tidak Cacat' ?></td>
							<td><?php echo $value->nama_user ?></td>
							<td><?php echo $value->penerima ?></td>
						</tr>
					<?php $no++; $total += $value->jumlah; endforeach ?>
				<?php else : ?>
					<tr>
						<td colspan="9"><p>Data Kosong</p></td>
					</tr>
				<?php endif; ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="5" align="right"><b>Total</b></td>
					<td align="center"><b><?php echo ribuan($total); ?></b></td>
					<td colspan="3"></td>
				</tr>
			</tfoot>
		</table>
		<input type='hidden' id='current' name='current' value='<?php echo $paging['current'] ?>'>
	</div>
	<div class='row'>
		<div class='col-sm-4 col-xs-12' style='margin-top:5px;margin-bottom:10px'>
			Total data <?php echo $paging['count_row'] ?> Rows
		</div>
		<div class='col-sm-8 col-xs-12 pull-right' style='margin-top:5px;margin-bottom:10px'>
			<?php echo $paging['list']; ?>
		</div>
	</div>

<script type="text/javascript">
	$(document).ready(function(){
    	$('.select-me').select2();

		$('#KategoriFind').change(function(){
			find();
		});

		$('#NomorFind, #BarangFind, #PetugasFind').keypress(function(event) {
			if (event.which==13) {
				find();
			}
		});

		$('#TanggalFind').daterangepicker({
			cancelClass: 'btn-danger',
			showDropdowns: true,
			alwaysShowCalendars: true,
			showCustomRangeLabel: false,
			autoUpdateInput: false,
			locale: {
				format: 'DD-MM-YYYY',
				separator: ' s/d ',
				applyLabel: 'Ok',
				cancelLabel: 'Clear',
				daysOfWeek: ['Mg', 'Sn', 'Sl', 'Rb', 'Km', 'Jm','Sb'],
				monthNames: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
				firstDay: 0
			}
		}).on('apply.daterangepicker', function(ev, picker) {
			$(this).val(picker.startDate.format('DD-MM-YYYY') + ' s/d ' + picker.endDate.format('DD-MM-YYYY'));
			find();
		}).on('cancel.daterangepicker', function(ev, picker) {
			$(this).val('');
			find();
		});
	});

	$('.btnAdd').click(function(){
		$.get(adminsite+"/proses/retur/add", function(content, status){
			BootstrapDialog.show({
				type: BootstrapDialog.TYPE_DEFAULT,
				size: BootstrapDialog.SIZE_WIDE,
				title:  '<strong>Tambah retur barang</strong>',
				message:$('<div></div>').append(content),
				buttons: [{
					label: 'Batal',
					cssClass: 'btn btn-danger',
					icon: 'fa fa-undo',
					action: function(dialog) {
						dialog.close();
					}
				},{
					label: 'Simpan',
					cssClass: 'btn btn-success',
					icon: 'fa fa-plus-circle',
					action: function(dialog) {
						dialog.enableButtons(false);
						dialog.setClosable(false);
						$.post(adminsite+"/proses/retur/action", $('#myform').serialize(), function(data, status){
							if (!data.result) {
								dialog.enableButtons(true);
            					toastr["error"](data.note, data.title);
							}
							else {
								toastr["success"](data.note, data.title);
								dialog.close();
								pageLoad('/proses/retur/listdata/',1);
							}
						});
					}
				}],
				onshown: function(dialog) {
					dialog.setClosable(false);
				}
			});
		});
	});

	$('.btnRefresh').click(function() {
		pageLoad('/proses/retur/listdata/', 1);
	});

	function find () {
		var keyword = {
			nomor: $('#NomorFind').val(),
			barang: $('#BarangFind').val(),
			petugas: $('#PetugasFind').val(),
			kategori: $('#KategoriFind').val(),
			tanggal: $('#TanggalFind').val()
			};

		pageLoad('/proses/retur/listdata/', 1, keyword);
	}
</script>
